VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsFTPClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'----------------------------------------------------------
'
'     clsFTPClass.cls
'
'     Funktionssammlung fr FTP Filetransfer
'
'     Autor:      peter.k.sauer@web.de
'
'     created:       11.2004
'     update:     18.12.2004
'----------------------------------------------------------

Option Explicit

Private Declare Function InternetConnect Lib "wininet.dll" Alias _
        "InternetConnectA" (ByVal hInternetSession As Long, _
        ByVal sServerName As String, ByVal nServerPort As Integer, _
        ByVal sUsername As String, ByVal sPassword As String, _
        ByVal lService As Long, ByVal lFlags As Long, ByVal _
        lContext As Long) As Long

Private Declare Function InternetSetOption Lib "wininet" Alias _
        "InternetSetOptionA" (ByVal hInternet As Long, _
        ByVal dwOption As Long, ByVal lpBuffer As Long, _
        ByVal dwBufferLength As Long) As Long

Private Declare Function InternetQueryOption Lib "wininet" Alias _
        "InternetQueryOptionA" (ByVal hInternet As Long, _
        ByVal dwOption As Long, ByRef lpBuffer As Long, _
        ByRef dwBufferLength As Long) As Long

Private Declare Function InternetOpen Lib "wininet.dll" Alias _
        "InternetOpenA" (ByVal sAgent As String, ByVal lAccessType _
        As Long, ByVal sProxyName As String, ByVal sProxyBypass _
        As String, ByVal lFlags As Long) As Long
       
Private Declare Function InternetCloseHandle Lib "wininet.dll" _
        (ByVal hInet As Long) As Integer

Private Declare Function FtpGetCurrentDirectory Lib "wininet.dll" _
        Alias "FtpGetCurrentDirectoryA" ( _
        ByVal hFtpSession As Long, _
        ByVal lpszDirectory As String, _
        ByRef lpdwCurrentDirectory As Long) As Boolean
                 
Private Declare Function FtpSetCurrentDirectory Lib "wininet.dll" _
        Alias "FtpSetCurrentDirectoryA" (ByVal hFtpSession As _
        Long, ByVal lpszDirectory As String) As Long
        
Private Declare Function FtpFindFirstFile Lib "wininet.dll" _
        Alias "FtpFindFirstFileA" (ByVal hFtpSession As Long, _
        ByVal lpszSearchFile As String, lpFindFileData As _
        WIN32_FIND_DATA, ByVal dwFlags As Long, ByVal dwContent _
        As Long) As Long
        
Private Declare Function FtpOpenFile Lib "wininet.dll" _
        Alias "FtpOpenFileA" (ByVal hFtpSession As Long, _
        ByVal lpszFileName As String, ByVal dwAccess As Long, _
        ByVal dwFlags As Long, ByVal dwContext As Long) As Long
        
Private Declare Function FtpGetFileSize Lib "wininet.dll" _
        (ByVal hFile As Long, ByRef FileSizeHigh As Long) As Long
        
Private Declare Function InternetFindNextFile Lib "wininet.dll" _
        Alias "InternetFindNextFileA" (ByVal hFind As Long, _
        lpvFindData As WIN32_FIND_DATA) As Long

Private Declare Function InternetReadFile Lib "wininet" _
        (ByVal hFile As Long, ByVal sBuffer As String, _
        ByVal lNumBytesToRead As Long, _
        lNumberOfBytesRead As Long) As Integer

Private Declare Function InternetWriteFile Lib "wininet.dll" _
        (ByVal hFile As Long, ByRef sBuffer As Byte, _
        ByVal lNumBytesToWite As Long, _
        dwNumberOfBytesWritten As Long) As Integer

Private Declare Function FtpGetFile Lib "wininet.dll" Alias _
        "FtpGetFileA" (ByVal hFtpSession As Long, ByVal _
        lpszRemoteFile As String, ByVal lpszNewFile As String, _
        ByVal fFailIfExists As Boolean, ByVal dwFlagsAndAttributes _
        As Long, ByVal dwFlags As Long, ByVal dwContext As Long) _
        As Long

Private Declare Function FtpPutFile Lib "wininet.dll" Alias _
        "FtpPutFileA" (ByVal hFtpSession As Long, ByVal _
        lpszLocalFile As String, ByVal lpszRemoteFile As String, _
        ByVal dwFlags As Long, ByVal dwContext As Long) As Long
       
Private Declare Function FtpDeleteFile Lib "wininet.dll" _
        Alias "FtpDeleteFileA" (ByVal hFtpSession As Long, _
        ByVal lpszFileName As String) As Long

Private Declare Function FtpRenameFile Lib "wininet.dll" _
        Alias "FtpRenameFileA" (ByVal hFtpSession As Long, _
        ByVal lpszFromFileName As String, ByVal lpszToFileName _
        As String) As Long
        
Private Declare Function FtpCreateDirectory Lib "wininet" _
        Alias "FtpCreateDirectoryA" (ByVal hFtpSession As _
        Long, ByVal lpszDirectory As String) As Long

Private Declare Function FtpRemoveDirectory Lib "wininet" _
        Alias "FtpRemoveDirectoryA" (ByVal hFtpSession As _
        Long, ByVal lpszDirectory As String) As Long

Private Declare Function InternetGetLastResponseInfo Lib _
        "wininet.dll" Alias "InternetGetLastResponseInfoA" _
        (lpdwError As Long, ByVal lpszBuffer As String, _
        lpdwBufferLength As Long) As Long
    
Private Declare Function FileTimeToSystemTime Lib "kernel32" _
        (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) _
        As Long
    
Private Const ERROR_NO_MORE_FILES = 18

Private Const FTP_TRANSFER_TYPE_BINARY = &H0
Private Const FTP_TRANSFER_TYPE_ASCII = &H1

Private Const INTERNET_OPTION_CONNECTED_STATE = 50
Private Const INTERNET_STATE_CONNECTED = &H1
Private Const INTERNET_STATE_DISCONNECTED_BY_USER = &H10
Private Const ISO_FORCE_DISCONNECTED = &H1

Private Const INTERNET_FLAG_PASSIVE = &H8000000
Private Const INTERNET_FLAG_RELOAD = &H80000000
Private Const INTERNET_FLAG_KEEP_CONNECTION = &H400000
Private Const INTERNET_FLAG_MULTIPART = &H200000
Private Const INTERNET_FLAG_NO_CACHE_WRITE = &H4000000

Private Const INTERNET_OPEN_TYPE_PRECONFIG = 0
Private Const INTERNET_OPEN_TYPE_DIRECT = 1
Private Const INTERNET_OPEN_TYPE_PROXY = 3

Private Const INTERNET_INVALID_PORT_NUMBER = 0
Private Const INTERNET_DEFAULT_FTP_PORT = 21
Private Const INTERNET_DEFAULT_GOPHER_PORT = 70
Private Const INTERNET_DEFAULT_HTTP_PORT = 80
Private Const INTERNET_DEFAULT_HTTPS_PORT = 443
Private Const INTERNET_DEFAULT_SOCKS_PORT = 1080

Private Const INTERNET_SERVICE_FTP = 1
Private Const INTERNET_SERVICE_GOPHER = 2
Private Const INTERNET_SERVICE_HTTP = 3

Private Const MAX_PATH = 260
Private Const NO_ERROR = 0
Private Const FILE_ATTRIBUTE_READONLY = &H1
Private Const FILE_ATTRIBUTE_HIDDEN = &H2
Private Const FILE_ATTRIBUTE_SYSTEM = &H4
Private Const FILE_ATTRIBUTE_DIRECTORY = &H10
Private Const FILE_ATTRIBUTE_ARCHIVE = &H20
Private Const FILE_ATTRIBUTE_NORMAL = &H80
Private Const FILE_ATTRIBUTE_TEMPORARY = &H100
Private Const FILE_ATTRIBUTE_COMPRESSED = &H800
Private Const FILE_ATTRIBUTE_OFFLINE = &H1000

Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000

'internet error flags
Private Const INTERNET_ERROR_BASE = 12000
Private Const ERROR_INTERNET_OUT_OF_HANDLES = (INTERNET_ERROR_BASE + 1)
Private Const ERROR_INTERNET_TIMEOUT = (INTERNET_ERROR_BASE + 2)
Private Const ERROR_INTERNET_EXTENDED_ERROR = (INTERNET_ERROR_BASE + 3)
Private Const ERROR_INTERNET_INTERNAL_ERROR = (INTERNET_ERROR_BASE + 4)
Private Const ERROR_INTERNET_INVALID_URL = (INTERNET_ERROR_BASE + 5)
Private Const ERROR_INTERNET_UNRECOGNIZED_SCHEME = (INTERNET_ERROR_BASE + 6)
Private Const ERROR_INTERNET_NAME_NOT_RESOLVED = (INTERNET_ERROR_BASE + 7)
Private Const ERROR_INTERNET_PROTOCOL_NOT_FOUND = (INTERNET_ERROR_BASE + 8)
Private Const ERROR_INTERNET_INVALID_OPTION = (INTERNET_ERROR_BASE + 9)
Private Const ERROR_INTERNET_BAD_OPTION_LENGTH = (INTERNET_ERROR_BASE + 10)
Private Const ERROR_INTERNET_OPTION_NOT_SETTABLE = (INTERNET_ERROR_BASE + 11)
Private Const ERROR_INTERNET_SHUTDOWN = (INTERNET_ERROR_BASE + 12)
Private Const ERROR_INTERNET_INCORRECT_USER_NAME = (INTERNET_ERROR_BASE + 13)
Private Const ERROR_INTERNET_INCORRECT_PASSWORD = (INTERNET_ERROR_BASE + 14)
Private Const ERROR_INTERNET_LOGIN_FAILURE = (INTERNET_ERROR_BASE + 15)
Private Const ERROR_INTERNET_INVALID_OPERATION = (INTERNET_ERROR_BASE + 16)
Private Const ERROR_INTERNET_OPERATION_CANCELLED = (INTERNET_ERROR_BASE + 17)
Private Const ERROR_INTERNET_INCORRECT_HANDLE_TYPE = (INTERNET_ERROR_BASE + 18)
Private Const ERROR_INTERNET_INCORRECT_HANDLE_STATE = (INTERNET_ERROR_BASE + 19)
Private Const ERROR_INTERNET_NOT_PROXY_REQUEST = (INTERNET_ERROR_BASE + 20)
Private Const ERROR_INTERNET_REGISTRY_VALUE_NOT_FOUND = (INTERNET_ERROR_BASE + 21)
Private Const ERROR_INTERNET_BAD_REGISTRY_PARAMETER = (INTERNET_ERROR_BASE + 22)
Private Const ERROR_INTERNET_NO_DIRECT_ACCESS = (INTERNET_ERROR_BASE + 23)
Private Const ERROR_INTERNET_NO_CONTEXT = (INTERNET_ERROR_BASE + 24)
Private Const ERROR_INTERNET_NO_CALLBACK = (INTERNET_ERROR_BASE + 25)
Private Const ERROR_INTERNET_REQUEST_PENDING = (INTERNET_ERROR_BASE + 26)
Private Const ERROR_INTERNET_INCORRECT_FORMAT = (INTERNET_ERROR_BASE + 27)
Private Const ERROR_INTERNET_ITEM_NOT_FOUND = (INTERNET_ERROR_BASE + 28)
Private Const ERROR_INTERNET_CANNOT_CONNECT = (INTERNET_ERROR_BASE + 29)
Private Const ERROR_INTERNET_CONNECTION_ABORTED = (INTERNET_ERROR_BASE + 30)
Private Const ERROR_INTERNET_CONNECTION_RESET = (INTERNET_ERROR_BASE + 31)
Private Const ERROR_INTERNET_FORCE_RETRY = (INTERNET_ERROR_BASE + 32)
Private Const ERROR_INTERNET_INVALID_PROXY_REQUEST = (INTERNET_ERROR_BASE + 33)
Private Const ERROR_INTERNET_NEED_UI = (INTERNET_ERROR_BASE + 34)
Private Const ERROR_INTERNET_HANDLE_EXISTS = (INTERNET_ERROR_BASE + 36)
Private Const ERROR_INTERNET_SEC_CERT_DATE_INVALID = (INTERNET_ERROR_BASE + 37)
Private Const ERROR_INTERNET_SEC_CERT_CN_INVALID = (INTERNET_ERROR_BASE + 38)
Private Const ERROR_INTERNET_HTTP_TO_HTTPS_ON_REDIR = (INTERNET_ERROR_BASE + 39)
Private Const ERROR_INTERNET_HTTPS_TO_HTTP_ON_REDIR = (INTERNET_ERROR_BASE + 40)
Private Const ERROR_INTERNET_MIXED_SECURITY = (INTERNET_ERROR_BASE + 41)
Private Const ERROR_INTERNET_CHG_POST_IS_NON_SECURE = (INTERNET_ERROR_BASE + 42)
Private Const ERROR_INTERNET_POST_IS_NON_SECURE = (INTERNET_ERROR_BASE + 43)
Private Const ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED = (INTERNET_ERROR_BASE + 44)
Private Const ERROR_INTERNET_INVALID_CA = (INTERNET_ERROR_BASE + 45)
Private Const ERROR_INTERNET_CLIENT_AUTH_NOT_SETUP = (INTERNET_ERROR_BASE + 46)
Private Const ERROR_INTERNET_ASYNC_THREAD_FAILED = (INTERNET_ERROR_BASE + 47)
Private Const ERROR_INTERNET_REDIRECT_SCHEME_CHANGE = (INTERNET_ERROR_BASE + 48)
Private Const ERROR_INTERNET_DIALOG_PENDING = (INTERNET_ERROR_BASE + 49)
Private Const ERROR_INTERNET_RETRY_DIALOG = (INTERNET_ERROR_BASE + 50)
Private Const ERROR_INTERNET_HTTPS_HTTP_SUBMIT_REDIR = (INTERNET_ERROR_BASE + 52)
Private Const ERROR_INTERNET_INSERT_CDROM = (INTERNET_ERROR_BASE + 53)
Private Const ERROR_INTERNET_FORTEZZA_LOGIN_NEEDED = (INTERNET_ERROR_BASE + 54)
Private Const ERROR_INTERNET_SEC_CERT_ERRORS = (INTERNET_ERROR_BASE + 55)
Private Const ERROR_INTERNET_SEC_CERT_NO_REV = (INTERNET_ERROR_BASE + 56)
Private Const ERROR_INTERNET_SEC_CERT_REV_FAILED = (INTERNET_ERROR_BASE + 57)

' FTP API errors
Private Const ERROR_FTP_TRANSFER_IN_PROGRESS = (INTERNET_ERROR_BASE + 110)
Private Const ERROR_FTP_DROPPED = (INTERNET_ERROR_BASE + 111)
Private Const ERROR_FTP_NO_PASSIVE_MODE = (INTERNET_ERROR_BASE + 112)

' gopher API errors
Private Const ERROR_GOPHER_PROTOCOL_ERROR = (INTERNET_ERROR_BASE + 130)
Private Const ERROR_GOPHER_NOT_FILE = (INTERNET_ERROR_BASE + 131)
Private Const ERROR_GOPHER_DATA_ERROR = (INTERNET_ERROR_BASE + 132)
Private Const ERROR_GOPHER_END_OF_DATA = (INTERNET_ERROR_BASE + 133)
Private Const ERROR_GOPHER_INVALID_LOCATOR = (INTERNET_ERROR_BASE + 134)
Private Const ERROR_GOPHER_INCORRECT_LOCATOR_TYPE = (INTERNET_ERROR_BASE + 135)
Private Const ERROR_GOPHER_NOT_GOPHER_PLUS = (INTERNET_ERROR_BASE + 136)
Private Const ERROR_GOPHER_ATTRIBUTE_NOT_FOUND = (INTERNET_ERROR_BASE + 137)
Private Const ERROR_GOPHER_UNKNOWN_LOCATOR = (INTERNET_ERROR_BASE + 138)

' HTTP API errors
Private Const ERROR_HTTP_HEADER_NOT_FOUND = (INTERNET_ERROR_BASE + 150)
Private Const ERROR_HTTP_DOWNLEVEL_SERVER = (INTERNET_ERROR_BASE + 151)
Private Const ERROR_HTTP_INVALID_SERVER_RESPONSE = (INTERNET_ERROR_BASE + 152)
Private Const ERROR_HTTP_INVALID_HEADER = (INTERNET_ERROR_BASE + 153)
Private Const ERROR_HTTP_INVALID_QUERY_REQUEST = (INTERNET_ERROR_BASE + 154)
Private Const ERROR_HTTP_HEADER_ALREADY_EXISTS = (INTERNET_ERROR_BASE + 155)
Private Const ERROR_HTTP_REDIRECT_FAILED = (INTERNET_ERROR_BASE + 156)
Private Const ERROR_HTTP_NOT_REDIRECTED = (INTERNET_ERROR_BASE + 160)
Private Const ERROR_HTTP_COOKIE_NEEDS_CONFIRMATION = (INTERNET_ERROR_BASE + 161)
Private Const ERROR_HTTP_COOKIE_DECLINED = (INTERNET_ERROR_BASE + 162)
Private Const ERROR_HTTP_REDIRECT_NEEDS_CONFIRMATION = (INTERNET_ERROR_BASE + 168)

' additional Internet API error codes
Private Const ERROR_INTERNET_SECURITY_CHANNEL_ERROR = (INTERNET_ERROR_BASE + 157)
Private Const ERROR_INTERNET_UNABLE_TO_CACHE_FILE = (INTERNET_ERROR_BASE + 158)
Private Const ERROR_INTERNET_TCPIP_NOT_INSTALLED = (INTERNET_ERROR_BASE + 159)
Private Const ERROR_INTERNET_DISCONNECTED = (INTERNET_ERROR_BASE + 163)
Private Const ERROR_INTERNET_SERVER_UNREACHABLE = (INTERNET_ERROR_BASE + 164)
Private Const ERROR_INTERNET_PROXY_SERVER_UNREACHABLE = (INTERNET_ERROR_BASE + 165)
Private Const ERROR_INTERNET_BAD_AUTO_PROXY_SCRIPT = (INTERNET_ERROR_BASE + 166)
Private Const ERROR_INTERNET_UNABLE_TO_DOWNLOAD_SCRIPT = (INTERNET_ERROR_BASE + 167)
Private Const ERROR_INTERNET_SEC_INVALID_CERT = (INTERNET_ERROR_BASE + 169)
Private Const ERROR_INTERNET_SEC_CERT_REVOKED = (INTERNET_ERROR_BASE + 170)

' InternetAutodial specific errors
Private Const ERROR_INTERNET_FAILED_DUETOSECURITYCHECK = (INTERNET_ERROR_BASE + 171)
Private Const ERROR_INTERNET_NOT_INITIALIZED = (INTERNET_ERROR_BASE + 172)
Private Const ERROR_INTERNET_NEED_MSN_SSPI_PKG = (INTERNET_ERROR_BASE + 173)
Private Const ERROR_INTERNET_LOGIN_FAILURE_DISPLAY_ENTITY_BODY = (INTERNET_ERROR_BASE + 174)
Private Const INTERNET_ERROR_LAST = (INTERNET_ERROR_BASE + 174)


Public Enum FTP_InternetPort
   Invalid_Port_Number = INTERNET_INVALID_PORT_NUMBER
   Default_FTP_Port = INTERNET_DEFAULT_FTP_PORT
   Default_Gopher_Port = INTERNET_DEFAULT_GOPHER_PORT
   Default_HTTP_Port = INTERNET_DEFAULT_HTTP_PORT
   Default_HTTPS_Port = INTERNET_DEFAULT_HTTPS_PORT
   Default_Socks_Port = INTERNET_DEFAULT_SOCKS_PORT
End Enum

Public Enum FTP_InternetService
   Service_FTP = INTERNET_SERVICE_FTP
   Service_Gopher = INTERNET_SERVICE_GOPHER
   Service_HTTP = INTERNET_SERVICE_HTTP
End Enum

Public Enum FileTypesOnly
   All = 0
   OnlyFiles = 1
   OnlyDirectory = 2
End Enum

Private Type INTERNET_CONNECTED_INFO
   dwConnectedState  As Long
   dwFlags As Long
End Type

Private Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
  dwFileAttributes As Long
  ftCreationTime As FILETIME
  ftLastAccessTime As FILETIME
  ftLastWriteTime As FILETIME
  nFileSizeHigh As Long
  nFileSizeLow As Long
  dwReserved0 As Long
  dwReserved1 As Long
  cFileName As String * MAX_PATH
  cAlternate As String * 14
End Type

Private Type SYSTEMTIME
  wYear As Integer
  wMonth As Integer
  wDayOfWeek As Integer
  wDay As Integer
  wHour As Integer
  wMinute As Integer
  wSecond As Integer
  wMilliseconds As Integer
End Type

Public Enum FTPTransferFlagTypes
   TransferBinary = FTP_TRANSFER_TYPE_BINARY
   TransferText = FTP_TRANSFER_TYPE_ASCII
   TransferCache = &H0
   TransferPassive = INTERNET_FLAG_RELOAD
End Enum

'----------------------------------------------    'die Events bei Read/Write
Public Event FTPDownLoad(RemoteFile As String, _
                         FileLen As Long, _
                         ByteRead As Long, _
                         ByteReadTotal As Long, _
                         Percent As Single, _
                         Cancel As Boolean)

Public Event FTPUpLoad(RemoteFile As String, _
                       FileLen As Long, _
                       ByteRead As Long, _
                       ByteReadTotal As Long, _
                       Percent As Single, _
                       Cancel As Boolean)

Private mvarCurrentDirectory As String             'aktuelles Verzeichnis
Private mvarFTPSessionHwnd As Long                 'Hwnd der Session
Private mvarINetConnectionHwnd As Long             'hwnd Connection
Private mvarBufferLength As Long                   'Grsse Buffer (4096) Read/Write


'Offline oder Online schalten
Public Property Let Offline(ByVal vData As Boolean)

      If vData Then
         System_SetOffline
      Else
         System_SetOnline
      End If
End Property

'ist Offline oder Offline
Public Property Get Offline() As Boolean
      Offline = SystemOffline
End Property

Public Property Let BufferLength(ByVal vData As Long)
      mvarBufferLength = vData
End Property

Public Property Get BufferLength() As Long
      BufferLength = mvarBufferLength
End Property

Public Property Get INetConnectionHwnd() As Long
      INetConnectionHwnd = mvarINetConnectionHwnd
End Property

Public Property Get FTPSessionHwnd() As Long
      FTPSessionHwnd = mvarFTPSessionHwnd
End Property

Public Property Get CurrentDirectory() As String
      CurrentDirectory = mvarCurrentDirectory
End Property

'Upload hppchenweise mit Events beim Schreiben
Public Function WriteFile(ByVal LocalFile As String, ByVal ServerFile As String, _
                          TransferMode As FTPTransferFlagTypes, _
                          Optional ByVal NotOverWrite As Boolean = False, _
                          Optional ErrNumber As Long = 0, _
                          Optional ErrDescription As String = vbNullString) As Boolean
 
   Dim hFile As Long, ret As Long, Result As Long
   Dim FTPSession As Long
   Dim i As Long, j As Long, k As Long
   Dim ByteToRead As Double, ByteRead As Double
   Dim Percent As Single
   Dim FNr As Integer
   Dim LocalBuffer As String
   Dim Buffer() As Byte
   Dim FileList As Variant
   Dim Cancel As Boolean
   
      FTPSession = FTPSessionHwnd
      If mvarINetConnectionHwnd = 0 Then
         ErrNumber = 5000
         ErrDescription = "keine Internetverbindung"
         Exit Function
      ElseIf FTPSession = 0 Then
         ErrNumber = 5001
         ErrDescription = "keine aktive FTP Session"
         Exit Function
      End If

      If Len(Dir(LocalFile)) = 0 Then
         ErrNumber = 5002
         ErrDescription = "lokale Datei nicht gefunden"
         Exit Function
      End If
      
      'nicht berschreiben
      If NotOverWrite Then
         If GetFileNames(ServerFile, FileList, OnlyFiles) > 0 Then
            ErrNumber = 5003
            ErrDescription = "Remotefile existiert bereits"
            Exit Function
         End If
      End If
      
      'lokale Datei einlesen
      FNr = FreeFile
      On Error Resume Next
      Open LocalFile For Binary Access Read Shared As #FNr
      If Err.Number <> 0 Then
         ErrNumber = Err.Number
         ErrDescription = "Fehler beim Einlesen lokale Datei" & _
                          Space(10) & vbCrLf & vbCrLf & _
                          Err.Description & Space(10)
         On Error GoTo 0
         Exit Function
      End If
   
      On Error GoTo 0
      LocalBuffer = Space(LOF(FNr))
      Get #FNr, , LocalBuffer
      Close #FNr
      ByteToRead = Len(LocalBuffer)
      
      'Remotefile ffnen
      hFile = FtpOpenFile(FTPSession, ServerFile, _
                          GENERIC_WRITE, TransferMode, 0&)
      If hFile = 0 Then
         ErrNumber = 5004
         ErrDescription = "Fehler beim ffnen Remotefile"
         Exit Function
      End If
      
      'einen Event feuern
      RaiseEvent FTPUpLoad(ServerFile, CLng(ByteToRead), _
                           j&, CLng(ByteRead), Percent, Cancel)
      
      i = 1
      Do While i <= ByteToRead
         If Cancel Then
            ErrNumber = 5005
            ErrDescription = "canceled by user"
            Close #FNr
            InternetCloseHandle hFile
            DeleteFile ServerFile
            Exit Function
         End If
      
         j = BufferLength
         If (i + j - 1) > ByteToRead Then
            j = ByteToRead - i + 1
         End If
         'zu sendenden Teil umsetzen in ByteArray
         Buffer = StrConv(Mid(LocalBuffer, i, j), vbFromUnicode)
         
         If InternetWriteFile(hFile, Buffer(0), j, ret) = 0 Then
            Close #FNr
            ErrNumber = Err.LastDllError
            ErrDescription = GetInternetError(ErrNumber)
            InternetCloseHandle hFile
            DeleteFile ServerFile
            Exit Function
         End If
         
         'Ergebnisse anpassen
         ByteRead = ByteRead + j
         Percent = FormatNumber(((ByteRead * 100#) / ByteToRead), 2)
         
         'Event feuern
         RaiseEvent FTPUpLoad(ServerFile, CLng(ByteToRead), _
                              j, CLng(ByteRead), Percent, Cancel)
         If Cancel Then
            Close #FNr
            ErrNumber = 0
            ErrDescription = "canceled by user"
            InternetCloseHandle hFile
            DeleteFile ServerFile
            Exit Function
         End If
         
         i = i + j
      Loop
      
      InternetCloseHandle hFile
      WriteFile = True
      On Error GoTo 0
      Exit Function
      
Fehler:
      ErrNumber = Err.Number
      ErrDescription = Err.Description
      On Error GoTo 0
End Function

'eine Datei senden ohne Events
Public Function SendFile(ByVal LocalFile As String, ByVal ServerFile As String, _
                         ByVal dwFlags As Long, ByVal dwContext As Long, _
                         Optional ErrNumber As Long = 0, _
                         Optional ErrDescription As String = "") As Boolean
 
   Dim Result As Long
   Dim hFtpSession As Long
   
      hFtpSession = FTPSessionHwnd
      Result = FtpPutFile(hFtpSession, LocalFile, ServerFile, dwFlags, dwContext)
      If Result <> 0 Then
         SendFile = True
      Else
         Err.Number = Err.LastDllError
         ErrDescription = GetInternetError(ErrNumber)
      End If
End Function


'Download hppchenweise mit Events beim Lesen
Public Function ReadFile(ByVal ServerFile As String, ByVal LocalFile As String, _
                         TransferMode As FTPTransferFlagTypes, _
                         ByVal fFailIfExists As Boolean, _
                         Optional FileLenght As Long = 0, _
                         Optional ErrNumber As Long = 0, _
                         Optional ErrDescription As String = vbNullString) As Boolean
                        
   Dim hFile As Long, ret As Long
   Dim FTPSession As Long, FileSizeHigh As Long
   Dim ByteToRead As Double, ByteRead As Double
   Dim Percent As Single
   Dim FNr As Integer
   Dim Buffer As String
   Dim FileList As Variant
   Dim Cancel As Boolean
   
      FTPSession = FTPSessionHwnd
      If mvarINetConnectionHwnd = 0 Then
         ErrNumber = 5000
         ErrDescription = "keine Internetverbindung"
         Exit Function
      ElseIf FTPSession = 0 Then
         ErrNumber = 5001
         ErrDescription = "keine aktive FTP Session"
         Exit Function
      End If
      
      'Remotefile Open
      hFile = FtpOpenFile(FTPSession, ServerFile, GENERIC_READ, _
                          TransferMode, 0&)
                          
      If hFile = 0 Then
         ErrNumber = 5002
         ErrDescription = "RemoteFile kann nicht geffnet werden"
         Exit Function
      End If
                        
      'Dateilnge bergeben
      ByteToRead = FileLenght
      If FileLenght = 0 Then
         'auslesen, falls nicht bergeben
         ByteToRead = FtpGetFileSize(hFile, FileSizeHigh)
      End If
                        
      'lokale Datei ggf lschen oder Fehler
      On Error GoTo Fehler
      If Len(Dir(LocalFile)) > 0 Then
         If Not fFailIfExists Then
            Kill LocalFile
         Else
            Exit Function
         End If
      End If
      
      'lokale Datei ffnen/anlegen
      FNr = FreeFile
      Open LocalFile For Binary Access Write Lock Read Write As #FNr
      
      'Bufferlnge
      ret = BufferLength
      Buffer = Space$(BufferLength)
      
      RaiseEvent FTPDownLoad(ServerFile, CLng(ByteToRead), _
                             0&, CLng(ByteRead), Percent, Cancel)
      
      Do While ret = mvarBufferLength
         'auslesen in Bufferlnge
         If InternetReadFile(hFile, Buffer, mvarBufferLength, ret) = 0 Then
            ErrNumber = Err.LastDllError
            ErrDescription = GetInternetError(ErrNumber)
            Close #FNr
            Kill LocalFile
            InternetCloseHandle hFile
            Exit Function
         End If
         
         'wurde Rest ausgelesen
         If ret <> BufferLength Then
            Buffer = Left$(Buffer, ret)
         End If
         
         'Ergebnisse anpassen
         ByteRead = ByteRead + Len(Buffer)
         Percent = FormatNumber(((ByteRead * 100#) / ByteToRead), 2)
         
         'Event feuern
         RaiseEvent FTPDownLoad(ServerFile, CLng(ByteToRead), _
                                Len(Buffer), CLng(ByteRead), Percent, Cancel)
                                
         If Cancel Then
            ErrNumber = 5003
            ErrDescription = "canceled by user"
            Close #FNr
            Kill LocalFile
            InternetCloseHandle hFile
            Exit Function
         End If
         
         'lokal schreiben
         Put #FNr, , Buffer
      Loop
      Close #FNr
      
      InternetCloseHandle hFile
      ReadFile = True
      On Error GoTo 0
      Exit Function
      
Fehler:
      ErrNumber = Err.Number
      ErrDescription = Err.Description
      On Error GoTo 0
End Function

'eine Datei holen ohne Events
Public Function GetFile(ByVal ServerFile As String, ByVal LocalFile As String, _
                        ByVal fFailIfExists As Boolean, ByVal dwFlagsAndAttributes _
                        As VbFileAttribute, ByVal dwFlags As FTPTransferFlagTypes, _
                        ByVal dwContext As Long, _
                        Optional ErrNumber As Long = 0, _
                        Optional ErrDescription As String = "") As Boolean
        
   Dim Result As Long
   Dim hFtpSession As Long
   
      hFtpSession = FTPSessionHwnd
      Result = FtpGetFile(hFtpSession, ServerFile, LocalFile, _
                          fFailIfExists, dwFlagsAndAttributes, dwFlags, dwContext)
      If Result <> 0 Then
         GetFile = True
      Else
         ErrNumber = Err.LastDllError
         ErrDescription = GetInternetError(ErrNumber)
      End If
End Function

'Auskunft ber vorhandene File Informationen
Public Function GetFileInfo(ServerFile As String, _
                            Optional lAttribute As Long, _
                            Optional sAttribute As String, _
                            Optional FileLenght As Long, _
                            Optional FileCreated As Date, _
                            Optional FileLastAcces As Date, _
                            Optional FileLastWrite As Date, _
                            Optional ErrNumber As Long = 0, _
                            Optional ErrDescription As String = "") As Boolean

   Dim W32 As WIN32_FIND_DATA
   Dim hFtpSession As Long, hFile As Long
   Dim V As FILETIME

      'nach Datei suchen
      W32.cFileName = String(MAX_PATH, 0)
      hFtpSession = FTPSessionHwnd
      hFile = FtpFindFirstFile(hFtpSession, ServerFile, W32, 0&, 0&)
            
      If hFile = 0 Then
         ErrNumber = Err.LastDllError
         ErrDescription = GetInternetError(ErrNumber)
         Exit Function
      End If
      
      lAttribute = W32.dwFileAttributes
      If (lAttribute And FILE_ATTRIBUTE_READONLY) = FILE_ATTRIBUTE_READONLY Then
         sAttribute = sAttribute & ",- ReadOnly"
      End If
      If (lAttribute And FILE_ATTRIBUTE_HIDDEN) = FILE_ATTRIBUTE_HIDDEN Then
         sAttribute = sAttribute & ",- Hidden"
      End If
      If (lAttribute And FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY Then
         sAttribute = sAttribute & ",- Directory"
      End If
      If (lAttribute And FILE_ATTRIBUTE_ARCHIVE) = FILE_ATTRIBUTE_ARCHIVE Then
         sAttribute = sAttribute & ",- Archive"
      End If
      If (lAttribute And FILE_ATTRIBUTE_NORMAL) = FILE_ATTRIBUTE_NORMAL Then
         sAttribute = sAttribute & ",- Normal"
      End If
      If (lAttribute And FILE_ATTRIBUTE_TEMPORARY) = FILE_ATTRIBUTE_TEMPORARY Then
         sAttribute = sAttribute & ",- Temporary"
      End If
      If (lAttribute And FILE_ATTRIBUTE_COMPRESSED) = FILE_ATTRIBUTE_COMPRESSED Then
         sAttribute = sAttribute & ",- Compressed"
      End If
      If (lAttribute And FILE_ATTRIBUTE_OFFLINE) = FILE_ATTRIBUTE_OFFLINE Then
         sAttribute = sAttribute & ",- Offline"
      End If
   
      If Len(sAttribute) >= 1 Then
         sAttribute = Mid(sAttribute, 2)
      End If
      
      FileLenght = W32.nFileSizeLow
      FileCreated = GetFileTime(W32.ftCreationTime)
      FileLastAcces = GetFileTime(W32.ftLastAccessTime)
      FileLastWrite = GetFileTime(W32.ftLastWriteTime)

      'Handle freigeben
      InternetCloseHandle hFile
      
      GetFileInfo = True
End Function

'liefert Lnge einer Datei auf dem FTP Server
Public Function GetFileSize(FileName As String) As Long

   Dim SL As Long
   
      GetFileInfo FileName, , , SL
      GetFileSize = SL
End Function

'eine Datei auf dem Server lschen
Public Function DeleteFile(ServerFile As String, _
                           Optional ErrNumber As Long = 0, _
                           Optional ErrDescription As String = "") As Boolean

   Dim Result As Long
   Dim hFtpSession As Long
   
      hFtpSession = FTPSessionHwnd
      Result = FtpDeleteFile(hFtpSession, ServerFile)
      If Result <> 0 Then
         DeleteFile = True
      Else
         ErrNumber = Err.LastDllError
         ErrDescription = GetInternetError(ErrNumber)
      End If
End Function

'eine Datei umbenennen
Public Function RenameFile(ServerFile As String, _
                           NewFileName As String, _
                           Optional ErrNumber As Long = 0, _
                           Optional ErrDescription As String = "") As Boolean

   Dim Result As Long
   Dim hFtpSession As Long
   
      hFtpSession = FTPSessionHwnd
      Result = FtpRenameFile(hFtpSession, ServerFile, NewFileName)
      If Result <> 0 Then
         RenameFile = True
      Else
         ErrNumber = Err.LastDllError
         ErrDescription = GetInternetError(ErrNumber)
      End If
End Function

'ein Verzeichnis anlegen
Public Function CreateDirectory(FolderName As String, _
                                Optional ErrNumber As Long = 0, _
                                Optional ErrDescription As String = "") As Boolean

   Dim Result As Long
   Dim hFtpSession As Long
   
      hFtpSession = FTPSessionHwnd
      Result = FtpCreateDirectory(hFtpSession, FolderName)
      If Result <> 0 Then
         CreateDirectory = True
      Else
         ErrNumber = Err.LastDllError
         ErrDescription = GetInternetError(ErrNumber)
      End If
End Function

'ein Verzeichnis lschen
Public Function DeleteDirectory(FolderName As String, _
                                Optional ErrNumber As Long = 0, _
                                Optional ErrDescription As String = "") As Boolean

   Dim Result As Long
   Dim hFtpSession As Long
   
      hFtpSession = FTPSessionHwnd
      Result = FtpRemoveDirectory(hFtpSession, FolderName)
      If Result <> 0 Then
         DeleteDirectory = True
      Else
         ErrNumber = Err.LastDllError
         ErrDescription = GetInternetError(ErrNumber)
      End If
End Function

'eine Verbindung herstellen
Public Function ConnectFTP(ByVal sServerName As String, _
                           ByVal nServerPort As FTP_InternetPort, _
                           ByVal sUsername As String, _
                           ByVal sPassword As String, _
                           ByVal lService As FTP_InternetService, _
                           ByVal lFlags As Long, _
                           ByVal lContext As Long, _
                           Optional ErrNumber As Long = 0, _
                           Optional ErrDescription As String = "") As Boolean
                  
   Dim Result As Long

      Result = InternetConnect(INetConnectionHwnd, sServerName, _
                               nServerPort, sUsername, sPassword, _
                               lService, lFlags, lContext)
      If Result <> 0 Then
         mvarFTPSessionHwnd = Result
         ConnectFTP = True
      Else
         ErrNumber = Err.LastDllError
         ErrDescription = GetInternetError(ErrNumber)
      End If
End Function

'I-Net ffnen
Public Function ConnectInternet(ByVal sAgent As String, ByVal lAccessType _
                  As Long, ByVal sProxyName As String, ByVal sProxyBypass _
                  As String, ByVal lFlags As Long, _
                  Optional ErrNumber As Long = 0, _
                  Optional ErrDescription As String = "") As Boolean
      
   Dim Result As Long
      
      If INetConnectionHwnd <> 0 Then
         Exit Function
      End If
      
      Result = InternetOpen(sAgent, lAccessType, _
                            sProxyName, sProxyBypass, lFlags)
      If Result <> 0 Then
         mvarINetConnectionHwnd = Result
         ConnectInternet = True
      Else
         ErrNumber = Err.LastDllError
         ErrDescription = GetInternetError(ErrNumber)
      End If
End Function
        
'schliessen Internet
Public Function CloseInternet() As Boolean
        
   Dim Result As Long
      
      If INetConnectionHwnd <> 0 Then
         Result = InternetCloseHandle(INetConnectionHwnd)
         mvarINetConnectionHwnd = 0
         CloseInternet = True
      End If
End Function
        
'schliessen FTP Session
Public Function CloseFTP() As Boolean
        
   Dim Result As Long
      
      If FTPSessionHwnd <> 0 Then
         Result = InternetCloseHandle(FTPSessionHwnd)
         mvarFTPSessionHwnd = 0
         CloseFTP = True
      End If
End Function

'Dateien aus einem FTP Verzeichnis auslesen
'FileFilter: Name Datei oder Pattern
'FileList  : liefert Stringarray (n,0 to 3)
'            0=Filename 1=Attr 2=FileLen 3=WriteTime
'FileTypes: Filter All:Files:Folders
Public Function GetFileNames(FileFilter As String, FileList As Variant, _
                             Optional FileTyp As FileTypesOnly, _
                             Optional ErrNumber As Long = 0, _
                             Optional ErrDescription As String = "") As Long


   Dim Result As Long, hFile As Long
   Dim Count As Long, i As Long
   Dim hFtpSession As Long
   Dim W32 As WIN32_FIND_DATA
   Dim DoIt As Boolean
   Dim FileName As String
   Dim mFileList() As String, s() As String
   
      'Liste der gefundenen Files
      ReDim mFileList(3, 0)
      Count = 0
      
      'nach erster Datei suchen
      W32.cFileName = String(MAX_PATH, 0)
      hFtpSession = FTPSessionHwnd
      hFile = FtpFindFirstFile(hFtpSession, FileFilter, W32, 0&, 0&)
            
      If hFile = 0 Then
         ErrNumber = Err.LastDllError
         ErrDescription = GetInternetError(ErrNumber)
         Exit Function
      End If
            
      'weitere Files auslesen
      Do
         DoIt = True
         If FileTyp = OnlyDirectory Then
            If (W32.dwFileAttributes And vbDirectory) = 0 Then
               DoIt = False
            End If
         ElseIf FileTyp = OnlyFiles Then
            If (W32.dwFileAttributes And vbDirectory) <> 0 Then
               DoIt = False
            End If
         End If
         
         'Filenamen extrahieren
         FileName = vbNullString
         i = InStr(1, W32.cFileName, Chr(0))
         If i > 0 Then
            FileName = Left$(W32.cFileName, i - 1)
         End If
         If (FileName = ".") Or (FileName = "..") Then
            FileName = vbNullString
         End If
         If Len(FileName) = 0 Then
            DoIt = False
         End If
         
         If DoIt Then
            'mFileListe in Grsse anpassen, Daten speichern
            ReDim Preserve mFileList(3, Count)
            mFileList(0, Count) = FileName
            mFileList(1, Count) = CStr(W32.dwFileAttributes)
            mFileList(2, Count) = CStr(W32.nFileSizeLow)
            mFileList(3, Count) = GetFileTime(W32.ftLastWriteTime)
            Count = Count + 1
         End If
         
         'nach nchster Datei suchen
         W32.cFileName = String(MAX_PATH, 0)
         Result = InternetFindNextFile(hFile, W32)
         
         'nix mehr gefunden
         If Result = 0 Then
            Exit Do
         End If
      Loop
      
      'Handle freigeben
      InternetCloseHandle hFile
         
      'Anzahl gefundener Files zurckmelden
      GetFileNames = Count
      If Count > 0 Then
         ReDim s(UBound(mFileList, 2), 3)
         For i = LBound(s) To UBound(s)
            s(i, 0) = mFileList(0, i)
            s(i, 1) = mFileList(1, i)
            s(i, 2) = mFileList(2, i)
            s(i, 3) = mFileList(3, i)
         Next
         FileList = s()
      End If
End Function

'liefert das aktuelle FTP Directory
Public Function GetCurrentFTPDirectory() As String
   
   Dim bLen As Long, i As Long
   Dim Buffer As String
   Dim hFtpSession As Long
   
      hFtpSession = FTPSessionHwnd
   
      bLen = 256
      Buffer = Space(bLen)
      If FtpGetCurrentDirectory(hFtpSession, Buffer, bLen) Then
         i = InStr(Buffer, Chr(0))
         If i > 0 Then
            Buffer = Left(Buffer, i - 1)
         End If
         GetCurrentFTPDirectory = Buffer
      End If
End Function


'auf ein (neues) Verzeichnis wechseln
Public Function SetCurrentFTPDirectory(sPath As String, _
                                    Optional ErrNumber As Long = 0, _
                                    Optional ErrDescription As String = "") As Boolean

   Dim Result As Long
   Dim hFtpSession As Long
   
      hFtpSession = FTPSessionHwnd
      Result = FtpSetCurrentDirectory(hFtpSession, sPath)
      If Result <> 0 Then
         SetCurrentFTPDirectory = True
         'Property setzen
         mvarCurrentDirectory = sPath
      Else
         ErrNumber = Err.LastDllError
         ErrDescription = GetInternetError(ErrNumber)
      End If
End Function

'auf nchsten Folder wechseln
Public Function SetNextFTPDirectory(sFolder, _
                                 Optional ErrNumber As Long = 0, _
                                 Optional ErrDescription As String = "") As Boolean

   Dim i As Long
   Dim s As String
      
      'aktuellen Pfad bearbeiten
      s = mvarCurrentDirectory
      If Right$(s, 1) <> "/" Then
         s = s & "/"
      End If
      s = s & sFolder
      
      'Directory wechseln
      SetNextFTPDirectory = SetCurrentFTPDirectory(s, ErrNumber, ErrDescription)
End Function

'einen Folder zurck
Public Function SetPrevFTPDirectory(Optional ErrNumber As Long = 0, _
                                 Optional ErrDescription As String = "") As Boolean

   Dim i As Long
   Dim s As String
      
      'aktuellen Pfad bearbeiten
      s = mvarCurrentDirectory
      i = InStrRev(s, "/")
      If i <= 1 Then
         'steht schon auf Start
         If Len(mvarCurrentDirectory) = 1 Then
            Exit Function
         End If
         s = "/"
      Else
         s = Left$(s, i - 1)
      End If
      
      'Directory (zurck)setzen
      SetPrevFTPDirectory = SetCurrentFTPDirectory(s, ErrNumber, ErrDescription)
End Function

'liefert die Beschreibung zu einem Internet Fehler
Public Function GetInternetError(ByVal ErrNumber As Long) As String

   Dim Buffer As String, sErr As String
   Dim i As Long, Result As Long

      
      Select Case ErrNumber
         Case 12001: sErr = "No more handles could be generated at this time"
         Case 12002: sErr = "The request has timed out."
         Case 12003:
            i = 1024
            Buffer = Space(i)
            
            If InternetGetLastResponseInfo(ErrNumber, Buffer, i) Then
               i = InStr(1, Buffer, Chr(0))
               If i > 0 Then
                  Buffer = Left(Buffer, i - 1)
               End If
               sErr = Buffer
            Else
               sErr = "Extended error returned from server."
            End If
            
         Case 12004: sErr = "An internal error has occurred."
         Case 12005: sErr = "The URL is invalid."
         Case 12006: sErr = "The URL scheme could not be recognized, or is not supported."
         Case 12007: sErr = "The server name could not be resolved."
         Case 12008: sErr = "The requested protocol could not be located."
         Case 12009: sErr = "A request to InternetQueryOption or InternetSetOption specified an invalid option value."
         Case 12010: sErr = "The length of an option supplied to InternetQueryOption or InternetSetOption is incorrect for the type of option specified."
         Case 12011: sErr = "The request option can not be set, only queried. "
         Case 12012: sErr = "The Win32 Internet support is being shutdown or unloaded."
         Case 12013, 12014: sErr = "The login to an FTP server could " & _
                                    "not be completed, user name or password is incorrect."
'         Case 12014: sErr = "The request to connect and login to an FTP server could not be completed because the supplied password is incorrect. "
         Case 12015: sErr = "The request to connect to and login to an FTP server failed."
         Case 12016: sErr = "The requested operation is invalid. "
         Case 12017: sErr = "The operation was canceled, usually because the handle on which the request was operating was closed before the operation completed."
         Case 12018: sErr = "The type of handle supplied is incorrect for this operation."
         Case 12019: sErr = "The requested operation can not be carried out because the handle supplied is not in the correct state."
         Case 12020: sErr = "The request can not be made via a proxy."
         Case 12021: sErr = "A required registry value could not be located. "
         Case 12022: sErr = "A required registry value was located but is an incorrect type or has an invalid value."
         Case 12023: sErr = "Direct network access cannot be made at this time. "
         Case 12024: sErr = "An asynchronous request could not be made because a zero context value was supplied."
         Case 12025: sErr = "An asynchronous request could not be made because a callback function has not been set."
         Case 12026: sErr = "The required operation could not be completed because one or more requests are pending."
         Case 12027: sErr = "The format of the request is invalid."
         Case 12028: sErr = "The requested item could not be located."
         Case 12029: sErr = "The attempt to connect to the server failed."
         Case 12030: sErr = "The connection with the server has been terminated."
         Case 12031: sErr = "The connection with the server has been reset."
         Case 12036: sErr = "The request failed because the handle already exists."
         Case Else: sErr = "Error details not available."
      End Select
      
      GetInternetError = sErr
End Function


'liefert Datum einer File als Date
Private Function GetFileTime(fTime As FILETIME) As Date

   Dim sTime As SYSTEMTIME
   Dim s As String

      FileTimeToSystemTime fTime, sTime
      With sTime
         s = .wDay & "." & .wMonth & "." & .wYear & " " & _
             .wHour & ":" & .wMinute & ":" & .wSecond
      End With
      
      If (fTime.dwHighDateTime = 0) And _
         (fTime.dwLowDateTime) = 0 Then
         GetFileTime = 0
      Else
         GetFileTime = CDate(s)
      End If
End Function

' Globaler Offline-Modus gestartet?
Private Function SystemOffline() As Boolean

   Dim lState As Long
      
      If InternetQueryOption(0, INTERNET_OPTION_CONNECTED_STATE, _
                             lState, Len(lState)) <> 0 Then
      
         SystemOffline = (lState And INTERNET_STATE_DISCONNECTED_BY_USER)
      End If
End Function

' System in den Offlinebetrieb setzen
Private Sub System_SetOffline()
   
   Dim uINFO As INTERNET_CONNECTED_INFO
   Dim lResult As Long
      
      With uINFO
         .dwConnectedState = INTERNET_STATE_DISCONNECTED_BY_USER
         .dwFlags = ISO_FORCE_DISCONNECTED
      End With
      
      lResult = InternetSetOption(0, INTERNET_OPTION_CONNECTED_STATE, _
                VarPtr(uINFO), Len(uINFO))
End Sub

' System in Onlinemodus setzen
Private Sub System_SetOnline()
   
   Dim uINFO As INTERNET_CONNECTED_INFO
   Dim lResult As Long

      With uINFO
         .dwConnectedState = INTERNET_STATE_CONNECTED
      End With
      
      lResult = InternetSetOption(0, INTERNET_OPTION_CONNECTED_STATE, _
                VarPtr(uINFO), Len(uINFO))
End Sub

'Start INI
Private Sub Class_Initialize()

      'Standard
      mvarCurrentDirectory = "/"
      'Buffer fr Read/Write
      mvarBufferLength = 4096
End Sub

'notfalls Verbindungen kappen
Private Sub Class_Terminate()

      If mvarINetConnectionHwnd <> 0 Then
         CloseInternet
      End If
      If mvarFTPSessionHwnd <> 0 Then
         CloseFTP
      End If
End Sub

